// option for seed ,randomize more 
// option to display node counts 
// option for restart or interrupt 
// qwhx,3doku,4doku,bobh,killer 
// print total, my,sigma,seed 

#include <stdio.h>
#include <time.h>
#include <windows.h>
#include <math.h>
#include <stdlib.h>
#define MAX_SIZE_ALPHABET 26*2+11
#define M 43
#define SR 5
#define MWC ( (zr=36969*(zr&65535)+(zr>>16)) ^ (wr=18000*(wr&65535)+(wr>>16)) )

int A[M][M],A0[M*M],U[M];
int Ur[M*M*M],Uc[4*M*M],V[4*M*M],Vc[4*M*M],Vd[4*M*M];
int Rows[4*M*M],Cols[M*M*M],Row[4*M*M][M],Col[M*M*M][5];
int C[4*M*M],R[M*M*M],I[M*M],Node[M*M],Two[M*M*4],C0[M*M*4];
int Z[(M*M>>SR)+1][M*M*4+9];
int t,p,sr,N,N2,N4,b,no,nz,mo,vc,n2,m2,t1,i4,c0,m0,m1,i,j,k,l,r,r1,c,c1,c2,n,m,x,y,s,multi;
int sud_qwh,seed,smax,min,max,nodes,tnodes,clues,guesses,solutions;
double fx,fy,mclock,my,sigma;

unsigned zr=362436069, wr=521288629;
char L[MAX_SIZE_ALPHABET]=".ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789abcdefghijklmnopqrstuvwxyz";
FILE *file;

int solve(int);
void __inline reduce(int);
void __inline unreduce(int);
void __inline reduce_matrix();

typedef unsigned char	u08;
typedef signed char	s08;
typedef unsigned int 	u16;
typedef signed int 	s16;
typedef unsigned long	u32;
typedef signed long	s32;

unsigned char FAT[8192], sharedmem[512], fat_directaccess;
unsigned short fat_size=240, fat_pos=0, fat_cnt=1, clcnt=500, startfatcnt, startfatoffs;

void mmc_read_sector(unsigned short s, unsigned char *buf) {
	int i;
	for (i=0; i<512; i++)
		buf[i] = FAT[i+s*512];
}

void mmc_write_sector(unsigned short s, unsigned char *buf) {
	int i;
	for (i=0; i<512; i++)
		FAT[i+s*512] = buf[i];
}

void test_fatwrite() {
	int i;
	unsigned short startcl, fatsect, lastfs, cnt, fatcl;
	unsigned char offscl, lastco, dirty;

		startcl = 2;	// Rechnet den Cluster der zu erstellenden Datei aus
		fatsect = fat_pos + (startcl>>8) + fat_size*i;	// Sektor der FAT mit dem Startcluster der zlD
		offscl = (unsigned char)startcl;	// Eintragsposition im FAT-Sektor bestimmen
		cnt = clcnt;

		mmc_read_sector(fatsect, sharedmem);	// FAT-Sektor lesen
		if (cnt == 1) {	// Datei braucht blo 1 Cluster
			sharedmem[offscl<<1] = 0xff;	// FAT-Eintrag schreiben
			sharedmem[(offscl<<1)+1] = 0xff;
		}
		else {
			lastfs = fatsect;
			lastco = offscl;
			dirty = 0;
			while (1) {
				offscl++;
				if (offscl == 0) {
					if (dirty) {
						mmc_write_sector(fatsect, sharedmem);
						dirty = 0;
					}
					fatsect++;
					mmc_read_sector(fatsect, sharedmem);
				}
				fatcl = sharedmem[offscl<<1];	// FAT-Eintrag lesen
				fatcl |= sharedmem[(offscl<<1)+1] << 8;
				if (fatcl == 0) {
					if (lastfs != fatsect) {
						if (dirty) {
							mmc_write_sector(fatsect, sharedmem);
							dirty = 0;
						}
						mmc_read_sector(lastfs, sharedmem);
					}
					if (cnt > 1) {
						sharedmem[lastco<<1] = offscl;	// FAT-Eintrag schreiben
						sharedmem[(lastco<<1)+1] = fatsect - fat_pos - i*fat_size;
						cnt--;
					}
					else {
						sharedmem[lastco<<1] = 0xff;	// FAT-Eintrag schreiben
						sharedmem[(lastco<<1)+1] = 0xff;
						break;
					}
					dirty = 1;
					if (lastfs != fatsect) {
						mmc_write_sector(lastfs, sharedmem);
						dirty = 0;
						mmc_read_sector(fatsect, sharedmem);
					}
					lastfs = fatsect;
					lastco = offscl;
				}
			}
		}
		mmc_write_sector(fatsect, sharedmem);	// genderten FAT-Sektor wegschreiben
}

/** Find next free cluster
    @return Cluster Number
*/
u16 find_free_cluster(void) {
	u16 fatsect, fatcl, cnt=clcnt-startfatcnt, pcnt=startfatcnt;
	u08 offscl=0;

	// FAT bearbeiten
	fatsect = fat_pos+startfatoffs;	// Sektor der FAT
	if (startfatoffs == 0)
		offscl = 2;
	fat_directaccess = 1;
	mmc_read_sector(fatsect, sharedmem);	// FAT-Sektor lesen
	fat_directaccess = 0;
	while (1) {
		fatcl = sharedmem[offscl<<1];	// FAT-Eintrag lesen
		fatcl |= sharedmem[(offscl<<1)+1] << 8;
		if (fatcl == 0) {
			pcnt++;
			cnt--;
			if (cnt == 0)
				return ((fatsect-fat_pos)<<8) + offscl;
		}
		offscl++;
		if (offscl == 0) {
			fatsect++;
			startfatoffs++;
			startfatcnt = pcnt;
//			if (fatsect == root_pos)	// Volle Karte!
//				return -1;
			fat_directaccess = 1;
			mmc_read_sector(fatsect, sharedmem);	// FAT-Sektor lesen
			fat_directaccess = 0;
		}
	}
}


int main(int argc,char*argv[]) {
	int acnt, numf, alf, numfe, alf2, alfe, alfe2, aa;

	for (i=0; i<8192; i++)
		FAT[i]=0;
	FAT[0]=0xff;
	FAT[1]=0xff;
	FAT[2]=0xff;
	FAT[3]=0xff;
	FAT[6]=0xff;
	FAT[7]=0xff;
	FAT[8]=0xff;
	FAT[9]=0xff;
	FAT[12]=0xff;
	FAT[13]=0xff;
	FAT[510]=0xff;
	FAT[511]=0xff;
	FAT[512]=0xff;
	FAT[513]=0xff;
	FAT[516]=0xff;
	FAT[517]=0xff;

	clcnt = 256;
	startfatcnt =0xfa;
	startfatoffs =1;

	//test_fatwrite();
	aa = find_free_cluster();

	return 0;

	printf("Speed-racing quasigroups-with-holes (yeah!) sudoku solver v1.3\n");
	if(argc<2) {
m5:
		printf("\nusage:%s file [q] [f] [a<file>|A...] [n] [m] [r<number>] [s<number>]\n\n", argv[0]);
		printf("solves the sudokus in the specified file\n\n");
		printf(" if 'q' is specified then views the puzzles as QWHs\n");
		printf(" if 'f' is specified then search stops at the first found solution\n");
		printf(" if 'a<file>' is specified then custom alphabet is used\n");
		printf("  else if 'A' is specified then the given alphabet is used\n");
		printf("  else autodetection of alphabet will be used\n");
		printf(" if 'n' is specified then don't print found solutions\n");
		printf(" if 'm' is specified then the file contains multiple sudokus\n");
		printf(" if 'r<number>' is specified then SR=number (must be > 5)\n");
		printf(" if 's<number>' is specified then seed=number\n");
		exit(1);
	}

	tnodes=0;
	smax=2147483647;
	sud_qwh=4;
	sr=8;
	p=1;
	aa=1;
	multi=0;
	seed=GetTickCount();

	// parameter parsing
	for(i=2;i<argc;i++) {
		if(argv[i][0]=='q')
			sud_qwh=3;
		if(argv[i][0]=='m')
			multi=1;
		if(argv[i][0]=='a') {
			if (file=fopen(&argv[i][1], "rb")) {
				fgets(L, MAX_SIZE_ALPHABET, file);
				fclose(file);
				aa=0;
			}
		}
		if(argv[i][0]=='A') {
			strncpy(L, &argv[i][1], MAX_SIZE_ALPHABET);
			aa=0;
		}
		if(argv[i][0]=='n')
			p=0;
		if(argv[i][0]=='f')
			smax=1;
		if(argv[i][0]=='r')
			sr=atoi(&(argv[i][1]));
		if(argv[i][0]=='s') {
			seed=atoi(&(argv[i][1]));
		}
	}

	zr+=seed;
	wr^=seed;
	nz=0;
	my=0;
	sigma=0;
	mclock=0;
	for(i=1;i<=4*M*M;i++) {
		j=1;
		while(j<=i)
			j+=j;
		Two[i]=j-1;
	}

	if((file=fopen(argv[1],"rb"))==NULL) {
		fclose(file);
		printf("\nfile-error\n\n");
		goto m5;
	}
	printf("Solving sudoku(s)...\n");
	if (aa) {
		acnt=1;
		L[0]='.';
		numf=0; alf=0; numfe=0; alf2=0; alfe=0; alfe2=0;
	}

	while (1) {
		t1=clock();
		i=0;
m1:
		if(feof(file)) {
			sigma=sqrt(sigma-my*my/nz)/sqrt(nz);
			my=my/nz;
			printf("\nstats:\nseed=%i samples=%i av.nodes=%i av.time=%f deviation=%f\n",seed,nz,tnodes/nz,my,sigma);
			//printf("\nav.time=%f\n",my);
			// for(i=1;i<13;i++)printf("%Li ",ZZ[i]);printf("\n");
			exit(1);
		}
		c=fgetc(file);j=0;
		if(c=='.'||c=='*'||c=='_')
			goto m7;
		else {
			if(c==10 && multi)
				goto m8;
			else if (!multi && feof(file))
				goto m8;
		}
		if (aa) {
			if (!numf && c>='1' && c<='9') {
				numf=1;
				for (j=0;j<9;j++)
					L[acnt++]='1'+j;
			}
			if (!numfe && c=='0') {
				numfe=1;
				L[acnt++]='0';
			}
			if (!alf && c>='A' && c<='F') {
				alf=1;
				for (j=0;j<6;j++)
					L[acnt++]='A'+j;
			}
			if (!alf2 && c>='a' && c<='f') {
				alf2=1;
				for (j=0;j<6;j++)
					L[acnt++]='a'+j;
			}
			if (!alfe && c>='G' && c<='Z') {
				alfe=1;
				for (j=6;j<26;j++)
					L[acnt++]='A'+j;
			}
			if (!alfe2 && c>='g' && c<='z') {
				alfe2=1;
				for (j=6;j<26;j++)
					L[acnt++]='a'+j;
			}
		}
		j=0;
		while(L[j]!=c && j<=M)
			j++;
		if(j>M)
			goto m1;
m7:
		i++;
		A0[i]=j;
		goto m1;
m8:
		N4=i;N2=0;
		while(N2*N2<N4)
			N2++;
		n=N4*N2;
		m=N4*sud_qwh;
		N=0;
		while(N*N<N2)
			N++;
		if(!N)
			continue;
		i=0;
		for(x=1;x<=N2;x++)
			for(y=1;y<=N2;y++) {
				i++;
				A[x][y]=A0[i];
			} 
	
		//printf("N=%i N2=%i N4=%i\n",N,N2,N4);
		//for(i=1;i<=N4;i++)printf("%c",L[A0[i]]);printf("\n");exit(8);
	
		for(i=0;i<=N4;i++)
			Node[i]=0;
		nodes=0;
		solve(smax);
		tnodes+=nodes;
		nz++;
		fx=clock();
		fy=fx-mclock;
		fy=fy/CLOCKS_PER_SEC;
		my+=fy;
		sigma+=fy*fy;
		mclock=fx; 
		if(!p)
			printf("\n%i sol. %8i nodes %8i guesses %5fsec\n",solutions,nodes,guesses,fy);
		else if (solutions==0)
			printf("\nNo solution found\n");
	}
}


int solve(int smax) {
	r=0;
	k=N;
	l=N2;
	for(x=1;x<=N2;x++)
		for(y=1;y<=N2;y++)
			for(s=1;s<=N2;s++) {
				r++;
				Cols[r]=sud_qwh;
				b=k*((x-1)/k)+(y-1)/k+1;
				Col[r][1]=x*N2-N2+y;
				Col[r][2]=x*N2-N2+s+N4*1;
				Col[r][3]=y*N2-N2+s+N4*2;
				Col[r][4]=b*N2-N2+s+N4*3;
			}
	for(i=1;i<=m;i++)
		Rows[i]=0;
	for(r=1;r<=n;r++)
		for(i=1;i<=Cols[r];i++) {
			c=Col[r][i];
			Rows[c]++;
			Row[c][Rows[c]]=r;
		}
	for(i=1;i<=N2;i++)
		U[i]=0;

	for(i=0;i<=(N4>>SR);i++)
		for(j=1;j<=m;j++)
			Z[i][j]=0;
	for(i=0;i<=n;i++)
		Ur[i]=0;
	for(i=0;i<=m;i++)
		Uc[i]=0;
	clues=0;
	for(x=1;x<=N2;x++)
		for(y=1;y<=N2;y++)
			if(A[x][y]) {
				U[A[x][y]]++;
				clues++;
				r=x*N4-N4+y*N2-N2+A[x][y];
				for(j=1;j<=Cols[r];j++) {
					c1=Col[r][j];
					if(Uc[c1])
						return -1;
					Uc[c1]++;
					for(k=1;k<=Rows[c1];k++) {
						r1=Row[c1][k];
						Ur[r1]++;
					}
				}
			}
	reduce_matrix();

	m0=0;
	m1=0;
	guesses=0;
	i=clues;
	solutions=0;
m2:
	i++;
	I[i]=0;
	min=n+1;
	if(i>N4 || m0)
		goto m4;
	if(m1) {
		C[i]=m1;
		goto m3;
	}
	c0=0;
	for(j=1;j<=vc;j++) {
		c=Vc[j];
		if(V[c]<=min) {
			c0++;
			C0[c0]=c;
		}
		if(V[c]<min) {
			min=V[c];
			c0=1;
			C[i]=c;
			C0[c0]=c;
			if(min<2)
				goto m3;
		}
	}
	if(min>1)
		guesses++;
m2a:
	c1=MWC&Two[c0];
	if(c1>=c0)
		goto m2a;
	c1++;
	C[i]=C0[c1];
	max=0;
	i4=i>>sr;
	for(j=1;j<=c0;j++) {
		c=C0[j];
		if(Z[i4][c]>max) {
			max=Z[i4][c];
			C[i]=c;
		}
	}
	// max=0;for(j=1;j<=c0;j++){c=C0[j];x=Size2(c);if(x>max){max=x;C[i]=c;}} 
	//max=0;for(j=1;j<=c0;j++){c=C0[j];s=0;for(k=1;k<=Rows[c];k++){r=Row[c][k]; 
	//if(!Ur[r]){l=R[r];x=N2;s+=U[(l-1)%x+1];}}if(s>max){max=s;C[i]=c;}} 

m3:
	c=C[i];
	I[i]++;
	if(I[i]>Rows[c])
		goto m4;
	r=Row[c][I[i]];
	if(Ur[r])
		goto m3;
	m0=0;
	m1=0;
	if(p) {
		l=R[r];
		j=N2;
		k=N4;
		x=(l-1)/k+1;
		y=((l-1)%k)/j+1;
		s=(l-1)%j+1;
		A[x][y]=s;
	}

	l=R[r];
	j=N2;
	s=(l-1)%j+1;
	U[s]++;

	for(j=1;j<=Cols[r];j++) {
		c1=Col[r][j];
		Uc[c1]++;
		c2=Vd[c1];
		t=Vc[c2];
		Vc[c2]=Vc[vc];
		Vc[vc]=t;
		Vd[Vc[c2]]=c2;
		Vd[Vc[vc]]=vc;
		vc--;
	}

	for(j=1;j<=Cols[r];j++)
		reduce(Col[r][j]);
	Node[i]++;
	nodes++;
	if(i==N4) {
		solutions++;
		if(p) {
			printf("\nSolution %u:\n", solutions);
			for(x=1;x<=N2;x++) {
				for(y=1;y<=N2;y++)
					printf("%c",L[A[x][y]]);
				if (!multi) printf("\n");
			}
			printf("\n");
		}
	}
	if(solutions==smax) {
		if(p)
			printf("\nmax. solutions reached!\n");
		goto m5;
	}
	goto m2;
m4:
	c=C[i];
	i4=i>>sr;
	Z[i4][c]+=1+nodes>>8;
	if(Z[i4][c]>200000000)
		for(j=0;j<(N4>>SR);j++)
			for(k=1;k<=m;k++)
				Z[j][k]=0;

	i--;
	c=C[i];
	r=Row[c][I[i]];

	l=R[r];
	j=N2;
	s=(l-1)%j+1;
	U[s]--;

	for(j=Cols[r];j>=1;j--) {
		c1=Col[r][j];
		Uc[c1]--;
		c2=Vd[c1];
		vc++;
		t=Vc[c2];
		Vc[c2]=Vc[vc];
		Vc[vc]=t;
	}

	for(j=1;j<=Cols[r];j++)
		unreduce(Col[r][j]);
	if(i>clues)
		goto m3;
m5:
	n=no;
	m=mo;
	return solutions;
}


void __inline reduce(int c) { // deletes c and N[c], updates V[],m0,m1
	int r,c2,k,l;
	for(k=1;k<=Rows[c];k++) {
		r=Row[c][k];
		Ur[r]++;
		if(Ur[r]==1)
			for(l=1;l<=Cols[r];l++) {
				c2=Col[r][l];
				V[c2]--;
				if(!Uc[c2]) {
					if(V[c2]<1)
						m0=c2;
					if(V[c2]<2)
						m1=c2;
				}
			}
	}
} 


void __inline unreduce(int c) {
	int r,c2,k,l;
	for(k=1;k<=Rows[c];k++) {
		r=Row[c][k];
		Ur[r]--;
		if(Ur[r]==0)
			for(l=1;l<=Cols[r];l++) {
				c2=Col[r][l];
				V[c2]++;
			}
	}
}

void __inline reduce_matrix() {
	mo=m;
	no=n;
	m=0;
	for(c=1;c<=mo;c++)
		if(Uc[c]==0) {
			m++;
			C0[c]=m;
		} 
	for(c=1;c<=m;c++)
		Rows[c]=0;
	r1=0;
	for(r=1;r<=n;r++)
		if(Ur[r]==0) {
			r1++;
			R[r1]=r;
			j=0;
			for(i=1;i<=Cols[r];i++) {
				c=Col[r][i];
				c1=C0[c];
				if(Uc[c]==0) {
					j++;
					Col[r1][j]=c1;
					Rows[c1]++;
					Row[c1][Rows[c1]]=r1;
				}
			}
			Cols[r1]=j;
		}
	n=r1;
	for(r=1;r<=n;r++)
		Ur[r]=0;
	for(c=1;c<=m;c++)
		Uc[c]=0;
	for(c=1;c<=m;c++) {
		Vc[c]=c;
		Vd[c]=c;
	}
	vc=m;
	for(c=1;c<=m;c++)
		V[c]=Rows[c];
}

